﻿using MindFusion.Diagramming.Wpf;
using MindFusion.Diagramming.Wpf.Export;
using MindfusionDemo.Items;
using Svg;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Windows;

namespace MindfusionDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Loaded += MainWindow_Loaded;
        }

        private void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            var diagram = new Diagram()
            {
                Bounds = new Rect(0, 0, 1920, 1080),
            };

            var point = new System.Windows.Point(100, 200);
            var text = new TextDiagramItem(text: "Some text", point);

            diagram.Items.Add(text);

            // See output [diagram.svg] file and its <text> attributes.
            // The <text> attribute must contains font-size = 36, font-family=heebo...
            // And other attrs which configured in text diagram item.
            var ms = ExportDiagram(diagram);
            ms.Seek(0, SeekOrigin.Begin);

            var svg = SvgDocument.Open<SvgDocument>(ms);
            // See svg [children] collection and SvgText instance.
            // It parses the svg file and can't parse FontSize, FontFamily etc. correctly.

            var sizedImage = new Bitmap((int)svg.Width.Value, (int)svg.Height.Value);
            svg.Draw(sizedImage);

            sizedImage.Save("test.png", ImageFormat.Png);
        }

        private static Stream ExportDiagram(Diagram diagram)
        {
            var exporter = new SvgExporter()
            {
                SetClipPaths = true,
            };

            var ms = new MemoryStream();
            exporter.Export(diagram, "diagram.svg");
            exporter.Export(diagram, ms);
            return ms;
        }
    }
}
